* PACKAGE DADMN    !" ϳإᥤѡ
*
*"  [HIS] 92/01/09 (momoko)
*"        95/08/14 (takepiro) 
*"        95/08/29 (takepiro) psi=const б
***********************************************************************
      SUBROUTINE DYNMCS
     M            (  PSI2  , ZETA2 , T2  , 
     M               PSI1  , ZETA1 , T1  , 
     I               HINTG , DT            )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
#include        "zhdim.F"            !" ʸʸ
*
* [MODIFY]
*" ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
*" ʻǡ(t-t) <DYNMCS>  ʻǡ(t)
      REAL PSI1  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(2STEP)
      REAL ZETA1 ( 0:NX+1 , 0:NZ+1 ) !" (2STEP)
      REAL T1    ( 0:NX+1 , 0:NZ+1 ) !" (2STEP)
*
* [INPUT]
      CHARACTER  HINTG * (NCC)       !" ʬå
*
      REAL DT                        !" ֳִ
*
* [INTERNAL WORK]
      REAL PSI3  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(STEP)
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
      REAL T3    ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
      REAL TNDZ  ( 0:NX+1 , 0:NZ+1 ) !" ϳغΰ
      REAL TNDT  ( 0:NX+1 , 0:NZ+1 ) !" ϳغΰ
*
      REAL AJAC  ( 0:NX+1 , 0:NZ+1 ) !" ϳغΰ
      REAL ALAP  ( 0:NX+1 , 0:NZ+1 ) !" ϳغΰ
*
* [INTERNAL SAVE]
      REAL RAYL                 !" 쥤꡼
      REAL PRND                 !" ץɥ
      REAL QINT                 !" ǮΨ
*
      REAL DX                   !" X γʻֳ
      REAL DZ                   !" Z γʻֳ
*
      LOGICAL OFIRST
      DATA    OFIRST  / .TRUE. /
*    
      SAVE  OFIRST , 
     &      RAYL   , PRND  , QINT, 
     &      DX     , DZ
*
*"        < 0. ѥ᥿ >
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL DPARM
     O        ( RAYL  , PRND  , QINT  )
*
         CALL ACRGET            !" ɸ
     O       (  DX , DZ  )
*
         CALL DBNSET            !" 
     I        ( PSI2 , 
     I          ZETA2, T2   ,
     I          DX   , DZ   )
      ENDIF
*
*"        < 1. ʬ >
*
      IF ( HINTG(1:1) .EQ. 'E' ) THEN
         CALL DEULER
     O        ( PSI3  , ZETA3 , T3  ,
     I          PSI2  , ZETA2 , T2  , 
     I          RAYL  , PRND  , QINT,
     C          DX    , DZ    , DT  ,
     W          AJAC  , ALAP          )
      ELSE IF ( HINTG(1:1) .EQ. 'H' ) THEN
         CALL DHEUN
     O        ( PSI3  , ZETA3 , T3  , 
     I          PSI2  , ZETA2 , T2  , 
     I          RAYL  , PRND  , QINT, 
     C          DX    , DZ    , DT  ,
     W          TNDZ  , TNDT  ,
     W          AJAC  , ALAP   ) 
      ELSE IF ( HINTG(1:1) .EQ. 'L' ) THEN 
         CALL DLPFRG
     O         ( PSI3  , ZETA3 , T3   ,
     I           PSI2  , ZETA2 , T2   , 
     I           PSI1  , ZETA1 , T1   , 
     I           RAYL  , PRND  , QINT ,
     C           DX    , DZ    , DT  ,
     W           AJAC  , ALAP   ) 
      ELSE IF ( HINTG(1:1) .EQ. 'R' ) THEN
         CALL DRUNGE
     O        ( PSI3  , ZETA3 , T3  ,
     I          PSI2  , ZETA2 , T2  , 
     I          RAYL  , PRND  , QINT,
     C          DX    , DZ    , DT  ,
     W          PSI1  , ZETA1 , T1  , 
     W          TNDZ  , TNDT  ,
     W          AJAC  , ALAP          )
      ELSE
         CALL MSGDMP( 'E', 'DYNMCS', 
     &                'SCHEME OF TIME INTEGRATION NOT SUPPORTED' )
      ENDIF
*
*"        < 2. PSI,T,ZETAΥǡ򤺤餹 >
*
      CALL COPY( PSI1 , PSI2 , (NX+2)*(NZ+2) )
      CALL COPY( T1   , T2   , (NX+2)*(NZ+2) )
      CALL COPY( ZETA1, ZETA2, (NX+2)*(NZ+2) )
*
      CALL COPY( PSI2 , PSI3 , (NX+2)*(NZ+2) )
      CALL COPY( T2   , T3   , (NX+2)*(NZ+2) )
      CALL COPY( ZETA2, ZETA3, (NX+2)*(NZ+2) )
*
      RETURN
      END
***********************************************************************
      SUBROUTINE  DPARM                        !" ϳإѥ᥿
     O             ( RAYL ,  PRND  , QINT )
*
*   [OUTPUT]
      REAL       RAYL           !" 쥤꡼
      REAL       PRND           !" ץɥ
      REAL       QINT           !" ǮΨ
*
*   [NAMELIST]
      REAL       RAYLI, SRAYL   !" 쥤꡼
      REAL       PRNDL, SPRND   !" ץɥ
      REAL       QINTR, SQINT   !" ǮΨ
*
*   [INTERNAL WORK]
      INTEGER    IFPAR, JFPAR
      LOGICAL    OFIRST
*
* [NAMELIST DEFALUT]
      NAMELIST    /NMDYN/  RAYLI, PRNDL, QINTR
      DATA  RAYLI , PRNDL , QINTR 
     &     /  0.0 ,   1.0 ,   0.0 /
*      
      DATA OFIRST  /.TRUE./
      SAVE SRAYL, SPRND, SQINT
*
*"         < 1. NAMELIST ɤ߹ >
*
      IF ( OFIRST )THEN
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMDYN , END=1190 )
 1190    WRITE  ( JFPAR, NMDYN  )
*
         SRAYL   = RAYLI
         SPRND   = PRNDL
         SQINT   = QINTR
      ENDIF
*
*"         < 2. ѥ᥿ν >
*
      RAYL   = SRAYL
      PRND   = SPRND
      QINT   = SQINT
*
      RETURN
      END
