* PACKAGE DZ2PSI    !" ٤ήؿ( psi=const.)
*
*"  [HIS] 96/03/14 (takepiro) TZ2PSI ܿ
*
***********************************************************************
*"        <<<  = ң ģԡģ  >>>
**********************************************************************
      SUBROUTINE DTMP2Z          !"  ٤鱲٤η׻(P inf )
     O             ( ZETA  , 
     I               T     , 
     C               RAYL  , 
     C               DX    , DZ    , DT  ,
     W               RDTDX    )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL ZETA ( 0:NX+1 , 0:NZ+1 )  !" (STEP)
*
* [INPUT]
      REAL T    ( 0:NX+1 , 0:NZ+1 )  !" (STEP)
*
      REAL RAYL                      !" 쥤꡼
*
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
      REAL DT                        !" ֳִ
*
* [WORK]
      REAL RDTDX ( 0:NX+1 , 0:NZ+1 ) !" Ϲ
*
*  [INTERNAL WORK]
      INTEGER IX                     !" 롼ץ
      INTEGER IZ                     !" 롼ץ
*
*"        < 1. Ϲη׻ >
*
      DO 1020 IZ = 1 , NZ
        DO 1010 IX = 1 , NX
           RDTDX( IX,IZ ) = RAYL*( T(IX+1,IZ)-T(IX-1,IZ) )/(2.*DX) 
 1010   CONTINUE
 1020 CONTINUE
*
*"        < 2. ݥ >
*
      CALL DTDX2Z         !" ٷ٤鱲٤( zeta=0)
     O     ( ZETA , 
     I       RDTDX,
     I       DX    , DZ   )
*
      RETURN
      END
**********************************************************************
      SUBROUTINE DTDX2Z     !" ٷ٤鱲٤( zeta=0)
     O           ( ZETA , 
     I             RDTDX,
     I             DX    , DZ      )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL       ZETA ( 0:NX+1 , 0:NZ+1 )  !" 
*
* [INPUT]
      REAL       RDTDX( 0:NX+1 , 0:NZ+1 ) !" Ϲ
      REAL       DX             !" Xγʻֳ
      REAL       DZ             !" Zγʻֳ
*
* [INTERNAL SAVE]
      REAL      ALU  ( NX , NZ, -1:1  ) !" (3г)
      REAL      WTBL ( 2  , NX ) !" Ѵؿɽ
      LOGICAL   OFIRST
*
* [INTERNAL WORK]
      REAL      Z    ( NX , NZ ) !" 
      INTEGER 	IX, IZ
      INTEGER 	IFAC
*
      DATA    OFIRST / .TRUE. /
*
      SAVE    OFIRST, ALU, WTBL
*
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL DZ2PST     !" ݥηꤹ
     O        (  ALU  , 
     I           DX   , DZ  )
*
         CALL RFFTIM            !" FFT 3Ѵؿɽ
     I        ( NX    ,
     O          WTBL  , IFAC  )
*
      ENDIF
*
*"        < 1. RDTDX աꥨѴ. >
*
      CALL COPY( ZETA , RDTDX , (NX+2)*(NZ+2) )
*
      CALL FFT99Y                          !" FFT Ƥ
     M         ( ZETA  ,
     M           Z     ,
     C           WTBL  , 
     C           2     , NX  , NX+2  , 
     C           2     , NZ  , NZ+2  , 
     C           0                      )
*
*"        < 2. PSIΥաꥨʬ. >
*
      CALL LUSOL3   !" ̣ʬˤη׻ [ гѹ ]
     M      ( Z    ,
     I        ALU  ,
     D        1    , NX , NZ )
*
*"       < 3. եաꥨѴPSI. >
*
      CALL FFT99Y     !" FFT Ƥ
     M         ( ZETA  ,
     M           Z     ,
     C           WTBL  , 
     C           2     , NX  , NX+2  , 
     C           2     , NZ  , NZ+2  , 
     C           1                      )
*
*"       < 4. Ŭ >
*
      DO 4000 IX = 0, NX+1
	ZETA( IX, 0 )    = 0.0
	ZETA( IX, NZ+1 ) = 0.0
 4000 CONTINUE
*
      DO 4100 IZ = 0, NZ+1
         ZETA(    0, IZ ) = ZETA( NX, IZ ) !" Ū
         ZETA( NX+1, IZ ) = ZETA(  1, IZ ) !" Ū
 4100 CONTINUE
*
      RETURN
      END
